<?php
	require_once('BDecode.php');
	require_once('BEncode.php');
	
	$md5ip = md5($_SERVER['REMOTE_ADDR']);
	
	
	/* SHA-1 for < PHP 5 */
	function sha1_str2blks_SHA1($str)
	{
		$strlen_str = strlen($str);
		
		$nblk = (($strlen_str + 8) >> 6) + 1;
		
		for ($i=0; $i < $nblk * 16; $i++) $blks[$i] = 0;
		
		for ($i=0; $i < $strlen_str; $i++)
		{
			$blks[$i >> 2] |= ord(substr($str, $i, 1)) << (24 - ($i % 4) * 8);
		}
		
		$blks[$i >> 2] |= 0x80 << (24 - ($i % 4) * 8);
		$blks[$nblk * 16 - 1] = $strlen_str * 8;
		
		return $blks;
	}
	
	function sha1_safe_add($x, $y)
	{
		$lsw = ($x & 0xFFFF) + ($y & 0xFFFF);
		$msw = ($x >> 16) + ($y >> 16) + ($lsw >> 16);
	
		return ($msw << 16) | ($lsw & 0xFFFF);
	}
	
	function sha1_rol($num, $cnt)
	{
		return ($num << $cnt) | sha1_zeroFill($num, 32 - $cnt);  
	}
	
	function sha1_zeroFill($a, $b)
	{
		$bin = decbin($a);
	
		$strlen_bin = strlen($bin);
	
		$bin = $strlen_bin < $b ? 0 : substr($bin, 0, $strlen_bin - $b);
	
		for ($i=0; $i < $b; $i++) $bin = '0'.$bin;
		
		return bindec($bin);
	}
	
	function sha1_ft($t, $b, $c, $d)
	{
		if ($t < 20) return ($b & $c) | ((~$b) & $d);
		if ($t < 40) return $b ^ $c ^ $d;
		if ($t < 60) return ($b & $c) | ($b & $d) | ($c & $d);
	
		return $b ^ $c ^ $d;
	}
	
	function sha1_kt($t)
	{
		if ($t < 20) return 1518500249;
		if ($t < 40) return 1859775393;
		if ($t < 60) return -1894007588;
	
		return -899497514;
	}
	
	function ssha1($str, $raw_output=FALSE)
	{
		if ( $raw_output === TRUE ) return pack('H*', ssha1($str, FALSE));
	
		$x = sha1_str2blks_SHA1($str);
		$a = 1732584193;
		$b = -271733879;
		$c = -1732584194;
		$d = 271733878;
		$e = -1009589776;
		
		$x_count = count($x);
		
		for ($i = 0; $i < $x_count; $i += 16)
		{
		$olda = $a;
		$oldb = $b;
		$oldc = $c;
		$oldd = $d;
		$olde = $e;
		
		for ($j = 0; $j < 80; $j++)
		{
		$w[$j] = ($j < 16) ? $x[$i + $j] : sha1_rol($w[$j - 3] ^ $w[$j - 8] ^ $w[$j - 14] ^ $w[$j - 16], 1);
		
		$t = sha1_safe_add(sha1_safe_add(sha1_rol($a, 5), sha1_ft($j, $b, $c, $d)), sha1_safe_add(sha1_safe_add($e, $w[$j]), sha1_kt($j)));
		$e = $d;
		$d = $c;
		$c = sha1_rol($b, 30);
		$b = $a;
		$a = $t;
		}
		
		$a = sha1_safe_add($a, $olda);
		$b = sha1_safe_add($b, $oldb);
		$c = sha1_safe_add($c, $oldc);
		$d = sha1_safe_add($d, $oldd);
		$e = sha1_safe_add($e, $olde);
		}
		
		return sprintf('%08x%08x%08x%08x%08x', $a, $b, $c, $d, $e);
	}
	
	
	
	$uploaddir = "uploads"; // Where you want the files to upload to - Important: Make sure this folders permissions is 0777!
	$allowed_ext = "torrent"; // These are the allowed extensions of the files that are uploaded
	$max_size = "400000"; // 50000 is the same as 50kb; 400kb
	
	// Check Extension
	$extension = pathinfo($_FILES['file']['name']);
	$extension = $extension[extension];
	$allowed_paths = explode(", ", $allowed_ext);
	for($i = 0; $i < count($allowed_paths); $i++)
	{
		if ($allowed_paths[$i] == "$extension")
		{
			$ok = "1";
		}
	}
	
	// Check File Size
	if($ok == "1")
	{
		if($_FILES['file']['size'] > $max_size)
		{
		print "File size is too big!";
		exit;
		}
		
		// The Upload Part
		if(is_uploaded_file($_FILES['file']['tmp_name']))
		{
			move_uploaded_file($_FILES['file']['tmp_name'],$uploaddir.'/'.$md5ip);
		}
		
		
		$filedata = file_get_contents($uploaddir.'/'.$md5ip);
		
		$data = BDecode($filedata);
		
		$sha1d_hash  = ssha1(BEncode($data["info"]),true);
		$urlenc_hash = urlencode($sha1d_hash);
		$scrape_url  = makescrape($data["announce"],$urlenc_hash);
		
		if($scrape_url === false)
		{
			die("Can't get torrent info from tracker :-(");
		}
		else
		{
			//echo $scrape_url;
			$scraped_data  = file_get_contents($scrape_url);
			
			$scraped_array = BDecode($scraped_data);
			
			//var_dump($scraped_array);
			//echo "<br>Hash: $sha1d_hash<br>";
			foreach($scraped_array["files"] as $file_array)
			{
				echo "<b>Torrent</b>: ".$_FILES['file']['name']."<br>";
				//echo "<b>Name</b>: ".$file_array["name"]."<br>";
				echo "<b>Seeders</b>: ".$file_array["complete"]."<br>";
				echo "<b>Leechers</b>: ".$file_array["incomplete"]."<br>";
				echo "<b>Completed</b>: ".$file_array["downloaded"]."<br>";
			}
			
		}
	}
	else
	{
		print "Incorrect file extension!";
	}
	
	
	
	/* Creates a scrape URL from an announce URL and URL-encoded info_hash */
	function makescrape($announce_url,$info_hash)
	{
		$lastslash = strrpos($announce_url,"/");
		
		if(strtolower(substr($announce_url,$lastslash+1,8)) != "announce")
		{
			return false;
		}
		else
		{
			$base_url = substr($announce_url, 0, $lastslash+1);
			$end_url  = substr($announce_url, $lastslash+9);
			
			if(strpos($end_url,"?")) // if some GET args are already there
			{
				$scrape = $base_url."scrape".$end_url."&info_hash=".$info_hash;
			}
			else
			{
				$scrape = $base_url."scrape".$end_url."?info_hash=".$info_hash;
			}
			
			return $scrape;
		}
	}
?>